if not Watcher then return end

if select(2, UnitClass('player')) ~= "WARRIOR" then return end

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants
	
C["Shield Slam"], _, C["Shield Slam Icon"], C["Shield Slam Cost"] = GetSpellInfo(47488)
C["Revenge"], _, C["Revenge Icon"], C["Revenge Cost"] = GetSpellInfo(57823)
C["Hamstring"], _, C["Hamstring Icon"], C["Hamstring Cost"] = GetSpellInfo(1715)
C["Devastate"], _, C["Devastate Icon"], C["Devastate Cost"] = GetSpellInfo(47498)
C["Concussion Blow"], _, C["Concussion Blow Icon"], C["Concussion Blow Cost"] = GetSpellInfo(12809)
C["Shockwave"], _, C["Shockwave Icon"], C["Shockwave Cost"] = GetSpellInfo(46968)
C["Rend"], _, C["Rend Icon"], C["Rend Cost"] = GetSpellInfo(47465)
C["Mortal Strike"], _, C["Mortal Strike Icon"], C["Mortal Strike Cost"] = GetSpellInfo(47486)
C["Heroic Strike"], _, C["Heroic Strike Icon"], C["Heroic Strike Cost"] = GetSpellInfo(47450)
C["Slam"], _, C["Slam Icon"], C["Slam Cost"] = GetSpellInfo(47475)
C["Whirlwind"], _, C["Whirlwind Icon"], C["Whirlwind Cost"] = GetSpellInfo(1680)
C["Bloodthirst"], _, C["Bloodthirst Icon"], C["Bloodthirst Cost"] = GetSpellInfo(23881)
C["Overpower"], _, C["Overpower Icon"], C["Overpower Cost"] = GetSpellInfo(7384)
C["Execute"], _, C["Execute Icon"], C["Execute Cost"] = GetSpellInfo(47471)
C["Death Wish"], _, C["Death Wish Icon"], C["Death Wish Cost"] = GetSpellInfo(12292)
C["Bladestorm"], _, C["Bladestorm Icon"], C["Bladestorm Cost"] = GetSpellInfo(46924)
C["Sunder Armor"], _, C["Sunder Armor Icon"], C["Sunder Armor Cost"] = GetSpellInfo(2687)
C["Sunder Armor"], _, C["Sunder Armor Icon"], C["Sunder Armor Cost"] = GetSpellInfo(7386)
C["Berserker Rage"], _, C["Berserker Rage Icon"], C["Berserker Rage Cost"] = GetSpellInfo(18499)
C["Taste for Blood"] = GetSpellInfo(56638)
C["Slam!"] = GetSpellInfo(46916)
C["Sudden Death"] = GetSpellInfo(52437)


function Watcher:UNIT_SPELLCAST_SUCCEEDED()
end
	
function Watcher:RendInfo()
local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDebuff("target", index)
		if name == C["Rend"] and caster == "player" then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end	

function Watcher:SlamInfo()
local index = 1
	while UnitBuff("player", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitBuff("player", index)
		if name == C["Slam!"] then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end	

function Watcher:SAInfo()
local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDeuff("target", index)
		if name == C["Sunder Armor"] then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end	

function Watcher:HSInfo()
local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDeuff("target", index)
		if name == C["Hamstring"] then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end	

Watcher.priorityTable.name["SS"] = C["Shield Slam"]
Watcher.priorityTable.icon["SS"] = C["Shield Slam Icon"]
Watcher.priorityTable.check["SS"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Shield Slam"], C["Shield Slam Cost"], 0, 0,0) 
	end
	
Watcher.priorityTable.name["Revenge"] = C["Revenge"]
Watcher.priorityTable.icon["Revenge"] = C["Revenge Icon"]
Watcher.priorityTable.check["Revenge"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Revenge"], C["Revenge Cost"], 0, 0, 0) 
	end
	
Watcher.priorityTable.name["Rend"] = C["Rend"]
Watcher.priorityTable.icon["Rend"] = C["Rend Icon"]
Watcher.priorityTable.check["Rend"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:RendInfo(), false, 0, 1, C["Rend"], C["Rend Cost"], 0, 0, 0) 
		end

	
Watcher.priorityTable.name["Hamstring"] = C["Hamstring"]
Watcher.priorityTable.icon["Hamstring"] = C["Hamstring Icon"]
Watcher.priorityTable.check["Hamstring"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:HSInfo(), false, 0, 1, C["Hamstring"], C["Hamstring Cost"], 0, 0, 0) 
	end
		
Watcher.priorityTable.name["Devastate"] = C["Devastate"]
Watcher.priorityTable.icon["Devastate"] = C["Devastate Icon"]
Watcher.priorityTable.check["Devastate"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Devastate"], C["Devastate Cost"], 0, 0, 0) 
	end
	
		
Watcher.priorityTable.name["Berserker Rage"] = C["Berserker Rage"]
Watcher.priorityTable.icon["Berserker Rage"] = C["Berserker Rage Icon"]
Watcher.priorityTable.check["Berserker Rage"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Berserker Rage"], C["Berserker Rage Cost"], 0, 0, 0) 
	end
	
	Watcher.priorityTable.name["Sunder Armor"] = C["Sunder Armor"]
Watcher.priorityTable.icon["Sunder Armor"] = C["Sunder Armor Icon"]
Watcher.priorityTable.check["Sunder Armor"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Sunder Armor"], C["Sunder Armor Cost"], 0, 0, 0) 
	end
		
Watcher.priorityTable.name["Concussion Blow"] = C["Concussion Blow"]
Watcher.priorityTable.icon["Concussion Blow"] = C["Concussion Blow Icon"]
Watcher.priorityTable.check["Concussion Blow"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Concussion Blow"], C["Concussion Blow Cost"], 0, 0, 0) 
	end
		
Watcher.priorityTable.name["Shockwave"] = C["Shockwave"]
Watcher.priorityTable.icon["Shockwave"] = C["Shockwave Icon"]
Watcher.priorityTable.check["Shockwave"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Shockwave"], C["Shockwave Cost"], 0, 0, 0) 
	end
	
	Watcher.priorityTable.name["Bladestorm"] = C["Bladestorm"]
Watcher.priorityTable.icon["Bladestorm"] = C["Bladestorm Icon"]
Watcher.priorityTable.check["Bladestorm"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Bladestorm"], C["Bladestorm Cost"], 0, 0, 0) 
	end
	
	Watcher.priorityTable.name["Death Wish"] = C["Death Wish"]
Watcher.priorityTable.icon["Death Wish"] = C["Death Wish Icon"]
Watcher.priorityTable.check["Death Wish"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Death Wish"], C["Death Wish Cost"], 0, 0, 0) 
	end
	
Watcher.priorityTable.name["Mortal Strike"] = C["Mortal Strike"]
Watcher.priorityTable.icon["Mortal Strike"] = C["Mortal Strike Icon"]
Watcher.priorityTable.check["Mortal Strike"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Mortal Strike"], C["Mortal Strike Cost"], 0, 0, 0) 
	end
	
	Watcher.priorityTable.name["Heroic Strike"] = C["Heroic Strike"]
Watcher.priorityTable.icon["Heroic Strike"] = C["Heroic Strike Icon"]
Watcher.priorityTable.check["Heroic Strike"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Heroic Strike"], Watcher.db.char.warrior.hsragethresh, 0, 0, 0) 
	end	
	
Watcher.priorityTable.name["Bloodthirst"] = C["Bloodthirst"]
Watcher.priorityTable.icon["Bloodthirst"] = C["Bloodthirst Icon"]
Watcher.priorityTable.check["Bloodthirst"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Bloodthirst"], C["Bloodthirst Cost"], 0, 0, 0) 
	end
	
Watcher.priorityTable.name["Whirlwind"] = C["Whirlwind"]
Watcher.priorityTable.icon["Whirlwind"] = C["Whirlwind Icon"]
Watcher.priorityTable.check["Whirlwind"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Whirlwind"], C["Whirlwind Cost"], 0, 0, 0) 
	end	

	Watcher.priorityTable.name["Overpower"] = C["Overpower"]
Watcher.priorityTable.icon["Overpower"] = C["Overpower Icon"]
Watcher.priorityTable.check["Overpower"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Overpower"], C["Overpower Cost"], 0, 0, 0) 
	end	
	
	Watcher.priorityTable.name["Slam"] = C["Slam"]
Watcher.priorityTable.icon["Slam"] = C["Slam Icon"]
Watcher.priorityTable.check["Slam"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Slam"], C["Slam Cost"], 0, 0, 0) 
	end
	
	Watcher.priorityTable.name["Slam!"] = L["Slam Instant"]
Watcher.priorityTable.icon["Slam!"] = C["Slam Icon"]
Watcher.priorityTable.check["Slam!"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:SlamInfo(), true, 0, 1, C["Slam"], C["Slam Cost"], 0, 0, 0) 
	end
	
Watcher.priorityTable.name["Execute"] = C["Execute"]
Watcher.priorityTable.icon["Execute"] = C["Execute Icon"]
Watcher.priorityTable.check["Execute"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 0.2, C["Execute"], C["Execute Cost"], 0, 0, 0) 
	end
	
	Watcher.priorityTable.name["Sunder Armor"] = C["Sunder Armor"]
Watcher.priorityTable.icon["Sunder Armor"] = C["Sunder Armor Icon"]
Watcher.priorityTable.check["Sunder Armor"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:SAInfo(), false, 0, 0.2, C["Sunder Armor"], C["Sunder Armor Cost"], 0, Watcher.db.char.warrior.sunderarmor, 0) 
	end
			
Watcher.priorityTable.name["gcd"] = "GCD"
Watcher.priorityTable.icon["gcd"] = C["Devastate Icon"]
Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Devastate"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveIcon(FrameName, timeleft)
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			return
		end
		if start == 0 then
			FrameName.Text:Hide()
			FrameName:SetAlpha(0)
		else
			FrameName.Text:Show()
		end
	end 
